package evgeniy.martian.base.app;

import javax.swing.*;
import java.awt.*;

public class PlayerInformation extends Box {

    private final static String stepsFormat = "Шагов: %s";
    private final static String healthFormat = "Здоровья: %s";

    private final Label stepsText = new Label(String.format(stepsFormat, 0));
    private final Label healthText = new Label(String.format(healthFormat, 100));

    public PlayerInformation() {
        super(BoxLayout.X_AXIS);
    }

    public void init() {
        add(stepsText);
        add(healthText);
    }

    public void updateSteps(int value) {
        this.stepsText.setText(String.format(stepsFormat, value));
        this.updateUI();
    }

    public void updateHealth(int value) {
        this.healthText.setText(String.format(healthFormat, value));
        this.updateUI();
    }

}
