package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public class DoorTile extends Tile {

    private final Variant variant;

    public DoorTile(int x, int y, Variant variant) {
        super(Type.DOOR, x, y);
        this.variant = variant;
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public String name() {
        return variant.name();
    }

    public Variant getVariant() {
        return this.variant;
    }

    public enum Variant {

        A(KeyTile.Variant.A),
        B(KeyTile.Variant.B),
        C(KeyTile.Variant.C),
        D(KeyTile.Variant.D),
        E(KeyTile.Variant.E);

        private final KeyTile.Variant key;

        Variant(KeyTile.Variant key) {
            this.key = key;
        }

        public static Variant from(String id) {
            return valueOf(id.toUpperCase());
        }

        public static Variant from(KeyTile.Variant variant) {
            return values()[variant.ordinal()];
        }

        public KeyTile.Variant getKey() {
            return this.key;
        }

    }

}
