package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public class FireTile extends Tile {

    private final int damageMultiplier;

    public FireTile(int x, int y, int damageMultiplier) {
        super(Type.FIRE, x, y);
        this.damageMultiplier = damageMultiplier;
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public void standOn(Manager manager) {
        manager.setPlayerHealth(manager.getPlayerHealth() - 20 * damageMultiplier);
    }

    @Override
    public String name() {
        return String.valueOf(damageMultiplier);
    }

    public int getDamageMultiplier() {
        return this.damageMultiplier;
    }

}
