package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public class HealthTile extends Tile {

    public HealthTile(int x, int y) {
        super(Type.HEALTH, x, y);
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public void standOn(Manager manager) {
        manager.setPlayerHealth(100);
        manager.getLevel().set(x, y, new FloorTile(x, y));
    }

    @Override
    public String name() {
        return "H";
    }

    public String fullyName() { return String.format("H{%s, %s}", y, x); }

}
