package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public class KeyTile extends Tile {

    private final Variant variant;

    public KeyTile(int x, int y, Variant variant) {
        super(Type.KEY, x, y);
        this.variant = variant;
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public void standOn(Manager manager) {
        manager.getInventory().addKey(variant);
    }

    @Override
    public String name() {
        return variant.name().toLowerCase();
    }

    public Variant getVariant() {
        return this.variant;
    }

    public enum Variant {

        A, B, C, D, E;

        public static Variant from(String id) {
            return valueOf(id.toUpperCase());
        }

    }

}
