package evgeniy.martian.base.objects;

import evgeniy.martian.base.level.Level;
import evgeniy.martian.base.utils.MutablePosition;

public class Manager {

    private Level level = null;
    private final MoveTaskManager taskManager = new MoveTaskManager(this);

    private final Inventory inventory = new Inventory();
    private final MutablePosition playerPosition = new MutablePosition(0, 0);
    private int playerHealth = 100;

    private ActionListener listener = null;

    public Level getLevel() {
        return this.level;
    }

    public void setLevel(Level level) {
        this.level = level;
        if (this.level != null) {
            this.playerPosition.setFrom(this.level.getStartPosition());
        }
    }

    public MoveTaskManager getTaskManager() {
        return this.taskManager;
    }

    public Inventory getInventory() {
        return this.inventory;
    }

    public MutablePosition getPlayerPosition() {
        return this.playerPosition;
    }

    public int getPlayerHealth() {
        return this.playerHealth;
    }

    public void setPlayerHealth(int playerHealth) {
        this.playerHealth = playerHealth;
        if (listener != null) listener.onUpdateHealth(playerHealth);
    }

    public void updateSteps(int steps) {
        if (listener != null) listener.onUpdateStep(steps);
    }

    public void setListener(ActionListener listener) {
        this.listener = listener;
    }

    public interface ActionListener {

        default void onUpdateStep(int steps) {}

        default void onUpdateHealth(int health) {}

    }

}
