package evgeniy.martian.base.utils;

import java.util.Objects;

public class MutablePosition {

    private int x;
    private int y;

    public MutablePosition(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public int getX() {
        return this.x;
    }

    public void setX(int x) {
        this.x = x;
    }

    public int getY() {
        return this.y;
    }

    public void setY(int y) {
        this.y = y;
    }

    public MutablePosition setFrom(MutablePosition position) {
        this.x = position.x;
        this.y = position.y;
        return this;
    }

    public MutablePosition setFrom(Position position) {
        this.x = position.getX();
        this.y = position.getY();
        return this;
    }

    public MutablePosition plus(MutablePosition other) {
        this.x += other.x;
        this.y += other.y;
        return this;
    }

    public MutablePosition plus(int x, int y) {
        this.x += x;
        this.y += y;
        return this;
    }

    public Position toImmutable() {
        return new Position(this.x, this.y);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        MutablePosition that = (MutablePosition) o;
        return x == that.x && y == that.y;
    }

    @Override
    public int hashCode() {
        return Objects.hash(x, y);
    }

    @Override
    public String toString() {
        return String.format("{x=%d, y=%d}", x, y);
    }

}
