package evgeniy.martian.base.utils;

import java.util.Objects;

public class Position {

    private final int x;
    private final int y;

    public Position(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }

    public Position plus(Position other) {
        return new Position(this.x + other.x, this.y + other.y);
    }

    public Position plus(int x, int y) {
        return new Position(this.x + x, this.y + y);
    }

    public Position sub(Position other) {
        return new Position(this.x - other.x, this.y - other.y);
    }

    public Position sub(int x, int y) {
        return new Position(this.x - x, this.y - y);
    }

    public MutablePosition toMutable() {
        return new MutablePosition(this.x, this.y);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Position position = (Position) o;
        return x == position.x && y == position.y;
    }

    @Override
    public int hashCode() {
        return Objects.hash(x, y);
    }

    @Override
    public String toString() {
        return String.format("{x=%d, y=%d}", x, y);
    }
}
