package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public class BluePortalTile extends Tile {

    private final Variant variant;

    public BluePortalTile(int x, int y, Variant variant) {
        super(Type.BLUE_PORTAL, x, y);
        this.variant = variant;
    }

    public Variant getVariant() {
        return variant;
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public boolean canPassNow(Manager manager) {
        return true;
    }

    @Override
    public String name() {
        return null;
    }

    public enum Variant {

        F(OrangePortalTile.Variant.F),
        G(OrangePortalTile.Variant.G),
        H(OrangePortalTile.Variant.H),
        I(OrangePortalTile.Variant.I),
        J(OrangePortalTile.Variant.J);

        private final OrangePortalTile.Variant orange;

        Variant(OrangePortalTile.Variant orange) {
            this.orange = orange;
        }

        public OrangePortalTile.Variant toOrange() {
            return this.orange;
        }

        public static Variant from(String id) {
            return valueOf(id.toUpperCase());
        }

    }

}
