package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.level.tile.Tile;
import evgeniy.martian.base.objects.Manager;

public class ButtonTile extends Tile {

    private final Variant variant;

    public ButtonTile(int x, int y, Variant variant) {
        super(Type.BUTTON, x, y);
        this.variant = variant;
    }

    public Variant getVariant() {
        return variant;
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public boolean canPassNow(Manager manager) {
        return false; // fixme
    }

    @Override
    public String name() {
        return "";
    }

    public enum Variant {

        A, B, C, D;

        public static Variant from(String name) {
            for (Variant value : Variant.values()) {
                if (value.name().equalsIgnoreCase(name)) {
                    return value;
                }
            }
            throw new UnsupportedOperationException("unknown type " + name);
        }

    }

}
