package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public class DoorTile extends Tile {

    private final Variant variant;

    public DoorTile(int x, int y, Variant variant) {
        super(Type.DOOR, x, y);
        this.variant = variant;
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public boolean canPassNow(Manager manager) {
        return false;
    }

    @Override
    public String name() {
        return variant.name();
    }

    public Variant getVariant() {
        return this.variant;
    }

    public enum Variant {

        A(ButtonTile.Variant.A),
        B(ButtonTile.Variant.B),
        C(ButtonTile.Variant.C),
        D(ButtonTile.Variant.D);

        private final ButtonTile.Variant button;

        Variant(ButtonTile.Variant key) {
            this.button = key;
        }

        public static Variant from(String id) {
            return valueOf(id.toUpperCase());
        }

        public static Variant from(ButtonTile.Variant variant) {
            return values()[variant.ordinal()];
        }

        public ButtonTile.Variant getButton() {
            return this.button;
        }

    }

}
