package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public class OrangePortalTile extends Tile {

    private final OrangePortalTile.Variant variant;

    public OrangePortalTile(int x, int y, OrangePortalTile.Variant variant) {
        super(Type.ORANGE_PORTAL, x, y);
        this.variant = variant;
    }

    public OrangePortalTile.Variant getVariant() {
        return variant;
    }

    @Override
    public boolean canPass(Manager manager) {
        return true;
    }

    @Override
    public boolean canPassNow(Manager manager) {
        return true;
    }

    @Override
    public String name() {
        return null;
    }

    public enum Variant {

        F(BluePortalTile.Variant.F),
        G(BluePortalTile.Variant.G),
        H(BluePortalTile.Variant.H),
        I(BluePortalTile.Variant.I),
        J(BluePortalTile.Variant.J);

        private final BluePortalTile.Variant blue;

        Variant(BluePortalTile.Variant blue) {
            this.blue = blue;
        }

        public BluePortalTile.Variant toBlue() {
            return this.blue;
        }

        public static Variant from(String id) {
            return valueOf(id.toUpperCase());
        }

    }

}
