package evgeniy.martian.base.level.tile;

import evgeniy.martian.base.objects.Manager;

public abstract class Tile {

    protected final Type type;
    protected final int x;
    protected final int y;

    public Tile(Type type, int x, int y) {
        this.type = type;
        this.x = x;
        this.y = y;
    }

    public abstract boolean canPass(Manager manager);

    public abstract boolean canPassNow(Manager manager);

    public final Type getType() {
        return this.type;
    }

    public final int getX() {
        return this.x;
    }

    public final int getY() {
        return this.y;
    }

    public boolean is(Type type) {
        return this.type == type;
    }

    public abstract String name();

    public void standOn(Manager manager) {};

    public enum Type {

        FLOOR,
        WALL,
        START,
        EXIT,
        CUBE,
        DOOR,
        BUTTON,
        BLUE_PORTAL,
        ORANGE_PORTAL

    }

}
