package evgeniy.martian.base.utils;

import evgeniy.martian.base.level.Level;
import evgeniy.martian.base.level.tile.DoorTile;
import evgeniy.martian.base.level.tile.Tile;
import evgeniy.martian.base.objects.Manager;

import java.util.*;
import java.util.stream.Collectors;

import static evgeniy.martian.base.objects.pathfinding.AStarPathfinding.aStar;

public class GoalsFinder {
//
//    private final Manager manager;
//    private final Level level;
//
//    private final Map<Position, Entry> entryByPosition = new HashMap<>();
//
//    public GoalsFinder(Manager manager, Level level) {
//        this.manager = manager;
//        this.level = level;
//    }
//
//    public Deque<Position> findGoals() {
//        calcDependencies();
//        Deque<Position> goals = linkGoals();
//
//        goals.removeFirst();
//        goals.addLast(level.getEndPosition());
//
//        return applyDamage(goals);
//    }
//
//    private void calcDependencies() {
//        List<Position> doors = level.getDoors();
//        for (Position doorPosition : doors) {
//            DoorTile door = (DoorTile) level.get(doorPosition);
//            entryByPosition.put(doorPosition, new Entry(door.name(), doorPosition, level.getKey(door.getVariant())));
//        }
//
//        for (Entry entry : entryByPosition.values()) {
//            Deque<Position> path = aStar(manager, entry.keyPosition, entry.doorPosition);
//            if (!path.isEmpty()) path.removeLast();
//            for (Position position : path) {
//                Tile tile = level.get(position);
//                if (tile.is(Tile.Type.DOOR)) {
//                    entry.dependsOn.add(entryByPosition.get(position));
//                }
//            }
//        }
//    }
//
//    private Deque<Position> linkGoals() {
//        Deque<Position> goals = new ArrayDeque<>();
//        goals.addFirst(level.getStartPosition());
//
//        Set<Entry> allowedDepends = new HashSet<>();
//        Set<Position> collectedKeys = new HashSet<>();
//
//        while (true) {
//            List<Entry> handle = entryByPosition.values().stream().filter(entry -> entry.dependsOn.size() == 0).collect(Collectors.toList());
//            if (handle.isEmpty()) {
//                return goals;
//            }
//            if (handle.size() == 1) {
//                Entry entry = handle.get(0);
//                allowedDepends.add(entry);
//
//                Deque<Position> path = aStar(manager, goals.getLast(), entry.keyPosition);
//                if (!path.isEmpty()) path.removeLast();
//
//                for (Position position : path) {
//                    Tile tile = level.get(position);
//                    if (tile.is(Tile.Type.KEY)) {
//                        collectedKeys.add(position);
//                    }
//                }
//
//                if (!collectedKeys.contains(entry.keyPosition)) goals.addLast(entry.keyPosition);
//                collectedKeys.add(entry.keyPosition);
//                entryByPosition.remove(entry.doorPosition);
//            }
//            else {
//                List<Deque<Position>> pathFindings = new ArrayList<>();
//
//                for (Entry entry : handle) {
//                    Tile entryTile = level.get(entry.doorPosition);
//                    Position goal = level.getKey(((DoorTile) entryTile).getVariant());
//
//                    Deque<Position> path = aStar(manager, goals.getLast(), goal);
//                    if (!path.isEmpty()) path.removeFirst();
//
//                    pathFindings.add(path);
//                }
//
//                if (pathFindings.isEmpty()) return goals;
//
//                pathFindings.sort(Comparator.comparingInt(Deque::size));
//                for (Deque<Position> pathFinding : pathFindings) {
//                    if (pathFinding.isEmpty()) continue;
//                    Position keyPosition = pathFinding.removeLast();
//
//                    for (Position position : pathFinding) {
//                        Tile tile = level.get(position);
//                        if (tile.is(Tile.Type.KEY)) {
//                            collectedKeys.add(position);
//                        }
//                    }
//
//                    if (!collectedKeys.contains(keyPosition)) {
//                        DoorTile door = (DoorTile) level.get(pathFinding.getLast());
//                        keyPosition = level.getKey(door.getVariant());
//                        goals.addLast(keyPosition);
//                    }
//                }
//            }
//
//            for (Entry entry : entryByPosition.values()) {
//                entry.dependsOn.removeAll(allowedDepends);
//            }
//        }
//    }
//
//    private Deque<Position> applyDamage(Deque<Position> goals) {
//        Deque<Position> copy = new ArrayDeque<>(goals);
//        Deque<Position> modifiedGoals = new ArrayDeque<>();
//
//        Position currentPosition = level.getStartPosition();
//        int currentHealth = 100;
//
//        List<Position> healths = level.getHealths();
//
//        Position last = currentPosition;
//        goals: while (!copy.isEmpty()) {
//            Position goal = copy.removeFirst();
//
//            Deque<Position> path = aStar(manager, currentPosition, goal);
//            path.removeFirst();
//
//            int damage = 0;
//            for (Position position : path) {
//                Tile tile = level.get(position);
//
//                if (tile.is(Tile.Type.FIRE)) {
//                    FireTile fire = (FireTile) tile;
//                    int newDamage = damage + fire.getDamageMultiplier() * 20;
//                    if (currentHealth - newDamage < 1) {
//                        Position health = findHealth(last, healths, currentHealth);
//                        if (health == null) {
//                            return modifiedGoals;
//                        }
//                        healths.removeIf(pos -> pos.equals(health));
//                        currentHealth = 100;
//
//                        currentPosition = health;
//                        modifiedGoals.addLast(health);
//                        copy.addFirst(goal);
//
//                        last = position;
//                        continue goals;
//                    }
//                    currentHealth -= fire.getDamageMultiplier() * 20;
//                }
//                else if (tile.is(Tile.Type.HEALTH)) {
//                    currentHealth = 100;
//                }
//                last = position;
//            }
//            if (currentHealth > 0) {
//                modifiedGoals.addLast(goal);
//                currentPosition = goal;
//            }
//            else {
//                return goals;
//            }
//        }
//        return modifiedGoals;
//    }
//
//    private Position findHealth(Position currentPosition, List<Position> healths, int health) {
//        List<Deque<Position>> pathFindings = new ArrayList<>();
//
//        for (Position healthTile : healths) {
//            Deque<Position> path = aStar(manager, currentPosition, healthTile);
//            if (path.isEmpty()) continue;
//            else path.removeFirst();
//
//            int damage = 0;
//            for (Position position : path) {
//                Tile tile = level.get(position);
//                if (tile.is(Tile.Type.FIRE)) {
//                    FireTile fire = (FireTile) tile;
//                    damage += fire.getDamageMultiplier() * 20;
//                }
//            }
//            if (health - damage > 0) {
//                pathFindings.add(path);
//            }
//        }
//
//        if (pathFindings.isEmpty()) return null;
//
//        pathFindings.sort(Comparator.comparingInt(Deque::size));
//        return pathFindings.get(0).getLast();
//    }
//
//    public static class Entry {
//
//        private final String name;
//
//        private final Position doorPosition;
//        private final Position keyPosition;
//
//        private final Queue<Entry> dependsOn = new ArrayDeque<>();
//
//        public Entry(String name, Position doorPosition, Position keyPosition) {
//            this.name = name;
//            this.doorPosition = doorPosition;
//            this.keyPosition = keyPosition;
//        }
//
//        @Override
//        public String toString() {
//            return String.format("Entry{name=%s, position=%s, dependsOn=%s}", name, doorPosition, dependsOn.stream().map(entry -> entry.name).collect(Collectors.joining(", ", "[", "]")));
//        }
//    }

}
